console.log('loaded: gadget.js');

var font;
var color;
var opacity;
var timeformat;
var lang;
var showSeconds;
var showShadows;
// var negativeVerticalMargin;
// var negativeHorizontalMargin;

var toTime;
var toDate;
var toMonth;
var toDay;


function init() {
	console.log('[init gadget]');

	System.Gadget.settingsUI = 'settings.html';
	System.Gadget.onSettingsClosed = function() {
		readSettings();
		createTextObjects();
		refresh(false);
	};

	readSettings();
	createTextObjects();
	refresh(true);
}

function readSettings() {
	console.log('[readSettings]');
	
	font = System.Gadget.Settings.readString('font') || 'Arial';
	color = System.Gadget.Settings.readString('color') || 'white';
	opacity = System.Gadget.Settings.read('opacity') || 30;
	timeformat = System.Gadget.Settings.read('timeformat') || 'full';
	lang = System.Gadget.Settings.read('lang') || 0;
	showSeconds = System.Gadget.Settings.read('seconds') || false;
	showShadows = System.Gadget.Settings.read('shadow') || false;
	// negativeVerticalMargin = System.Gadget.Settings.read('negativeVerticalMargin') || 0;
	// negativeHorizontalMargin = System.Gadget.Settings.read('negativeHorizontalMargin') || 0;
	refreshLang();
	console.log('[refreshlang]');
	console.log('    font: '+font);
	console.log('    color: '+color);
	console.log('    opacity: '+opacity);
	console.log('    lang '+lang);
	
}

function createTextObjects() {
	console.log('[createTextObjects]');

	var bg = document.getElementById('bg');
	bg.removeObjects();

	// 0's are dummy chars for initial text object alignment
	toTime = bg.addTextObject('00:00', font, 105, color, 0, 0);
	toDate = bg.addTextObject('0', font, 80, color, 0, 90); //(toTime.top+toTime.height)*0.69);
	toMonth = bg.addTextObject('0', font, 45, color, toDate.left+toDate.width, 95);
	toDay = bg.addTextObject('0', font, 30, color, toDate.left+toDate.width, 135);
	
	//we really don't want to be changing the width of the gadget because of clock time
	//because gadgets are anchored on the desktop by the left side, and the content is right-aligned
	
	toTime.opacity = opacity;
	toDate.opacity = opacity;
	toMonth.opacity = opacity;
	toDay.opacity = opacity;
	if (showShadows == true) {
		toTime.addShadow('black', 20, 80, 5, 5);
		toDate.addShadow('black', 20, 80, 5, 5);
		toMonth.addShadow('black', 20, 80, 5, 5);
		toDay.addShadow('black', 20, 80, 5, 5);
		document.getElementsByTagName('body')[0].style.height = toDay.top + toDay.height + 5;
	}
	else  {
		document.getElementsByTagName('body')[0].style.height = toDay.top + toDay.height;
	}
}

function refresh(autoreload) {
	console.log('[refresh]');
	console.log('    font: '+font);
	console.log('    color: '+color);
	console.log('    opacity: '+opacity);
	console.log('    lang '+lang);

	var currentTime = System.Time.getLocalTime(System.Time.currentTimeZone);
	var currentDate = new Date(Date.parse(currentTime));
		//hh:mm:ss
	var hours = currentDate.getHours();
	var minutes = currentDate.getMinutes();
	minutes = ((minutes < 10) ? ':0' : ':') + minutes;
	if (showSeconds == true) {
	var seconds = currentDate.getSeconds();
	seconds = ((seconds < 10) ? ':0' : ':') + seconds;
	minutes = minutes+seconds;
	}
		//PMAM
	if (timeformat == 'half') {
		var meridiem = hours >= 12 ? ' PM' : ' AM';
		if(hours == 0) {
			hours = 12;
		}
		//values
		toTime.value = hours > 12 ? (hours-12) + minutes + meridiem : hours + minutes + meridiem;
	}
	else {
	toTime.value = hours < 10 ? '0' + hours + minutes : hours + minutes;
	}
	toDate.value = currentDate.getDate();
	toMonth.value = m[currentDate.getMonth()];
	toDay.value = d[currentDate.getDay()];
	
	
	//targetWidth = document.getElementsByTagName('body')[0].style.width;
	
	if ((toTime.Width < toDate.Width + toMonth.Width ) && (toMonth.Width > toDay.Width)) {
		document.getElementsByTagName('body')[0].style.width = (toDate.Width + toMonth.Width);
		//toTime.left = targetWidth - (toDate.Width + toMonth.Width); 
		}
	else if (toTime.Width < toDate.Width + toDay.Width) {
		document.getElementsByTagName('body')[0].style.width = toDate.Width + toDay.Width;
		//toTime.left = targetWidth - (toDate.Width + toDay.Width);
		}
	else {
	document.getElementsByTagName('body')[0].style.width = toTime.width;
	//toTime.left = targetWidth - toTime.width;
		}
	
	//toTime.top = 0;
	//toDate.left = toTime.left;
	toDate.top = 90; // - negativeVerticalMargin;

	toMonth.left = toDate.width;
	// goofly little formula here to goose the month riiiigh up to but not touching the time, for most fonts
	toMonth.top = toDate.top + 4 + (toDate.top * 0.05) ; //95;

	toDay.left = toMonth.left;
	toDay.top = toMonth.top + 41; //135;
	
	console.log('    width: '+toTime.width+', height: '+toDay.top + toDay.height);
	console.log('    toTime: x='+toTime.left+', y='+toTime.top+', h='+toTime.height+', w='+toTime.width);
	
	if (autoreload) {
		setTimeout(function() { refresh(true); }, 1000);
	}
}
